import React, { useState, useEffect } from 'react'
import {  Card, Col, Menu, Row, Select, Tabs } from 'antd';
// import './index.less'
import Campaign from './campaign';
import AdAccount from './adAccount';
import Ad from './ad';
import Creative from './creative';
import LandingPage from './landingPage';
import { getAdAccountAllOfMember } from '@/services/launchAdq/adq';
import Targeting from './targeting';
import { useAjax } from '@/Hook/useAjax';
import { IdcardFilled } from '@ant-design/icons';
import { useModel } from 'umi';
const { TabPane } = Tabs;
let Menus: any = Menu
const tabsConfig = [
    { key: '1', tab: '账户信息', jsx:(props: any) => <AdAccount {...props} />},
    { key: '2', tab: '计划', jsx:(props: any) => <Campaign {...props} />},
    { key: '3', tab: '广告', jsx: (props: any) => <Ad {...props} /> },
    { key: '4', tab: '创意', jsx: (props: any) => <Creative {...props} /> },
    { key: '5', tab: '落地页', jsx: (props: any) => <LandingPage {...props} /> },
    { key: '6', tab: '定向', jsx: (props: any) => <Targeting {...props} /> },
]
function Adq() {
    const userInfo = useModel('@@initialState', model => model.initialState?.currentUser)
    const allOfMember = useAjax(() => getAdAccountAllOfMember(), { formatResult: true })
    const [userAll, setUserAll] = useState([])
    const [activeKey, setActiveKey] = useState('1')
    const [userId, setUserId] = useState<any>('1'||userInfo?.userId?.toString())
    const [selectedArr, setSelectedArr] = useState([])
    const [idS, setIds] = useState({//需要用到的accountId，adAccountId
        accountId: '',
        adAccountId: ''
    })
    useEffect(() => {
        allOfMember.run().then(res => {
            if (res?.data) {
                let useAll: any = []
                res?.data?.forEach((item: { key: { userId: any; nickName: any; }; value: any[]; }) => {
                    let obj = {
                        key: item.key.userId,
                        label: item.key.nickName,
                        icon: <IdcardFilled />,
                    }
                    if (item?.value) {
                        obj['childrenarr'] = item?.value?.map(item => {
                            return { key: item.accountId + '_' + item.id, label: item.accountId }
                        })
                    }
                    useAll.push(obj)
                })
                setUserAll(useAll)
            }
        })
    }, [])
    useEffect(() => {
        if (userAll.length > 0 && userId) {
            let newArr: any = userAll?.filter((item: any) => item.key == userId)
            setSelectedArr(newArr[0]?.childrenarr || [])
        }
    }, [userAll, userId])
    console.log('selectedArr===>', selectedArr)
    return <Row style={{ position: 'relative' }}>
        <Col style={{ height: '100%', overflowY: 'auto', position: 'absolute', left: 0, top: 0, bottom: 0, width: 150, background: '#fff' }}>
            <Menus
                theme='light'
                onClick={(e: any) => {//点击菜单
                    setUserId(e.key)
                }}
                selectedKeys={userId}
                mode="inline"
                multiple={false}
                items={userAll}
            />
        </Col>
        <Col span={21} style={{ marginLeft: 150 }}>
            <Card>
                <Tabs activeKey={activeKey} type="card" onChange={(activeKey) => { setActiveKey(activeKey) }} tabBarExtraContent={
                    <Select placeholder='广点通账号' style={{ minWidth: 200 }} showSearch filterOption={(input: any, option: any) =>
                        (option!.children as unknown as string).toLowerCase().includes(input.toLowerCase())
                    } allowClear onChange={(value: any) => {
                        let accountId = ''
                        let adAccountId = ''
                        if (value) {
                            let arr = value.split('_')
                            accountId = arr[0]
                            adAccountId = arr[1]
                        }
                        setIds({ accountId, adAccountId })
                    }} >
                        {
                            selectedArr?.map((item: any) => {
                                return <Select.Option value={item.key} key={item.key}>{item.label}</Select.Option>
                            })
                        }
                    </Select>
                }>
                    {
                        tabsConfig?.map(item => {
                            return <TabPane tab={item.tab} key={item.key} >
                                {activeKey=== item.key && item.jsx({...idS, userId })}
                            </TabPane>
                        })
                    }
                </Tabs>
            </Card>
        </Col>
    </Row>

}
export default Adq